Subject: RE: bug#52293: [External] : bug#52293: 29.0.50; [PATCH v3] Prevent further cases of duplicated separators in context menus

From: Drew Adams <[email-masked]>
Date: Wed, 15 Dec 2021 21:36:54 +0000

> > Instead of a second single click always deleting, you
> > can use it to access a context menu, to delete or
> > perform any other actions.
> >
> > Doesn't that remove the standard second-click-deletes
> > behavior?  No, because it distinguishes a `mouse-3'
> > double-click (which performs the usual delete action)
> > from a second single click (which shows a context
> > menu - or in fact to do anything else you like).
> 
> So double-click mouse-3 pops up the context menu?

No - reread that, or read what I repeated, below.

> But no other app uses such a gesture.

No other app lets you do what Emacs lets you do
with mouse-3.  No other app lets you do lots of
things that Emacs lets you do.

> So no user would expect that the context menu should
> be invoked by double-clicking the right mouse button.

Not without learning about it or stumbling upon
it, perhaps.  The same is true for a great deal
of Emacs - wonderful features.

The first thing to learn is how to find out about
things.  And yes, even that takes some learning.

> Moreover, double-clicking mouse-3 is not convenient to use.

I disagree.  I'll bet it's what you're already
doing when (if) you right-click `mouse-3' to
kill selected text.  I'll bet you do NOT use a
second single-click.

And anyway, it's not a double-click that brings
up a menu - that continues to do what it's always
done in Emacs: delete the active region.  It's a
_second single-click_ (at the same spot) that
brings up the menu.

(That's a design choice, so as to fit best with
traditional Emacs behavior.  Those two could be
reversed: double-click to bring up menu, two
single-clicks to delete region.)
___

And again, there are simple user actions to get
ONLY what you apparently prefer or ONLY what
Emacs users are used to:

. It's trivial to choose to always get a context
  menu instead (and yes, with a single click):
  just turn on option `mouse3-menu-always-flag'.

. It's trivial to get only the longstanding Emacs
  mouse-3 behavior (never a context menu): just
  set option `mouse3-second-click-default-command'
  to `mouse3-kill/delete-region'.  (In Customize,
  choose "Kill/delete, per `mouse-drag-copy-region'"
  from the Value Menu.)

Better such a choice than no choice.

Better such a choice AND a 3rd choice - for the
behavior of offering both: context menu and
region-kill.
___

And the doc I pointed you to isn't a "wall of text".
It's short and to the point.  The library offers
lots of possibilities.  And that "wall" also
presents examples of how to create specialized
context-sensitive menus.
___

And this isn't the first time I've described the
behavior in emails to the mailing lists.  Either
you haven't paid attention, even in your own
thread introducing what you wanted to do for
context menus.  In this current thread I'm
repeating myself.  I don't mind, if you actually
listen or are interested.